# coding: utf-8

"""
    Pulp 3 API

    Fetch, Upload, Organize, and Distribute Software Packages  # noqa: E501

    The version of the OpenAPI document: v3
    Contact: pulp-list@redhat.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from pulpcore.client.pulp_cookbook.configuration import Configuration


class CookbookCookbookPackageContent(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'file': 'file',
        'upload': 'str',
        'artifact': 'str',
        'repository': 'str',
        'name': 'str',
        'version': 'str'
    }

    attribute_map = {
        'file': 'file',
        'upload': 'upload',
        'artifact': 'artifact',
        'repository': 'repository',
        'name': 'name',
        'version': 'version'
    }

    def __init__(self, file=None, upload=None, artifact=None, repository=None, name=None, version=None, local_vars_configuration=None):  # noqa: E501
        """CookbookCookbookPackageContent - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._file = None
        self._upload = None
        self._artifact = None
        self._repository = None
        self._name = None
        self._version = None
        self.discriminator = None

        if file is not None:
            self.file = file
        if upload is not None:
            self.upload = upload
        if artifact is not None:
            self.artifact = artifact
        if repository is not None:
            self.repository = repository
        self.name = name
        if version is not None:
            self.version = version

    @property
    def file(self):
        """Gets the file of this CookbookCookbookPackageContent.  # noqa: E501

        An uploaded file that may be turned into the artifact of the content unit.  # noqa: E501

        :return: The file of this CookbookCookbookPackageContent.  # noqa: E501
        :rtype: file
        """
        return self._file

    @file.setter
    def file(self, file):
        """Sets the file of this CookbookCookbookPackageContent.

        An uploaded file that may be turned into the artifact of the content unit.  # noqa: E501

        :param file: The file of this CookbookCookbookPackageContent.  # noqa: E501
        :type: file
        """

        self._file = file

    @property
    def upload(self):
        """Gets the upload of this CookbookCookbookPackageContent.  # noqa: E501

        An uncommitted upload that may be turned into the artifact of the content unit.  # noqa: E501

        :return: The upload of this CookbookCookbookPackageContent.  # noqa: E501
        :rtype: str
        """
        return self._upload

    @upload.setter
    def upload(self, upload):
        """Sets the upload of this CookbookCookbookPackageContent.

        An uncommitted upload that may be turned into the artifact of the content unit.  # noqa: E501

        :param upload: The upload of this CookbookCookbookPackageContent.  # noqa: E501
        :type: str
        """

        self._upload = upload

    @property
    def artifact(self):
        """Gets the artifact of this CookbookCookbookPackageContent.  # noqa: E501

        Artifact file representing the physical content  # noqa: E501

        :return: The artifact of this CookbookCookbookPackageContent.  # noqa: E501
        :rtype: str
        """
        return self._artifact

    @artifact.setter
    def artifact(self, artifact):
        """Sets the artifact of this CookbookCookbookPackageContent.

        Artifact file representing the physical content  # noqa: E501

        :param artifact: The artifact of this CookbookCookbookPackageContent.  # noqa: E501
        :type: str
        """

        self._artifact = artifact

    @property
    def repository(self):
        """Gets the repository of this CookbookCookbookPackageContent.  # noqa: E501

        A URI of a repository the new content unit should be associated with.  # noqa: E501

        :return: The repository of this CookbookCookbookPackageContent.  # noqa: E501
        :rtype: str
        """
        return self._repository

    @repository.setter
    def repository(self, repository):
        """Sets the repository of this CookbookCookbookPackageContent.

        A URI of a repository the new content unit should be associated with.  # noqa: E501

        :param repository: The repository of this CookbookCookbookPackageContent.  # noqa: E501
        :type: str
        """

        self._repository = repository

    @property
    def name(self):
        """Gets the name of this CookbookCookbookPackageContent.  # noqa: E501

        name of the cookbook  # noqa: E501

        :return: The name of this CookbookCookbookPackageContent.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this CookbookCookbookPackageContent.

        name of the cookbook  # noqa: E501

        :param name: The name of this CookbookCookbookPackageContent.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and name is None:  # noqa: E501
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                name is not None and len(name) < 1):
            raise ValueError("Invalid value for `name`, length must be greater than or equal to `1`")  # noqa: E501

        self._name = name

    @property
    def version(self):
        """Gets the version of this CookbookCookbookPackageContent.  # noqa: E501

        version of the cookbook  # noqa: E501

        :return: The version of this CookbookCookbookPackageContent.  # noqa: E501
        :rtype: str
        """
        return self._version

    @version.setter
    def version(self, version):
        """Sets the version of this CookbookCookbookPackageContent.

        version of the cookbook  # noqa: E501

        :param version: The version of this CookbookCookbookPackageContent.  # noqa: E501
        :type: str
        """
        if (self.local_vars_configuration.client_side_validation and
                version is not None and len(version) < 1):
            raise ValueError("Invalid value for `version`, length must be greater than or equal to `1`")  # noqa: E501

        self._version = version

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CookbookCookbookPackageContent):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, CookbookCookbookPackageContent):
            return True

        return self.to_dict() != other.to_dict()
